OGRE: Ogre::ParticleEmitter Class Reference - OGRE Documentation

# Ogre::ParticleEmitter Class Reference

Abstract class defining the interface to be implemented by particle emitters. More...

`#include <OgreParticleEmitter.h>`

Inheritance diagram for Ogre::ParticleEmitter:

[legend]

List of all members.

## Public Types
enum | ParticleType { Visual, Emitter }
| Type of particle. More...
## Public Member Functions
| ParticleEmitter (ParticleSystem *psys)
virtual | ~ParticleEmitter ()
| Virtual destructor essential.
virtual void | setPosition (const Vector3 &pos)
| Sets the position of this emitter relative to the particle system center.
virtual const Vector3 & | getPosition (void) const
| Returns the position of this emitter relative to the center of the particle system.
virtual void | setDirection (const Vector3 &direction)
| Sets the direction of the emitter.
virtual const Vector3 & | getDirection (void) const
| Returns the base direction of the emitter.
virtual void | setAngle (const Radian &angle)
| Sets the maximum angle away from the emitter direction which particle will be emitted.
virtual const Radian & | getAngle (void) const
| Returns the maximum angle which the initial particle direction can deviate from the emitters base direction.
virtual void | setParticleVelocity (Real speed)
| Sets the initial velocity of particles emitted.
virtual void | setParticleVelocity (Real min, Real max)
| Sets the initial velocity range of particles emitted.
virtual void | setMinParticleVelocity (Real min)
| Returns the minimum particle velocity.
virtual void | setMaxParticleVelocity (Real max)
| Returns the maximum particle velocity.
virtual Real | getParticleVelocity (void) const
| Returns the initial velocity of particles emitted.
virtual Real | getMinParticleVelocity (void) const
| Returns the minimum particle velocity.
virtual Real | getMaxParticleVelocity (void) const
| Returns the maximum particle velocity.
virtual void | setEmissionRate (Real particlesPerSecond)
| Sets the emission rate for this emitter.
virtual Real | getEmissionRate (void) const
| Returns the emission rate set for this emitter.
virtual void | setTimeToLive (Real ttl)
| Sets the lifetime of all particles emitted.
virtual void | setTimeToLive (Real minTtl, Real maxTtl)
| Sets the range of lifetime for particles emitted.
virtual void | setMinTimeToLive (Real min)
| Sets the minimum time each particle will live for.
virtual void | setMaxTimeToLive (Real max)
| Sets the maximum time each particle will live for.
virtual Real | getTimeToLive (void) const
| Gets the time each particle will live for.
virtual Real | getMinTimeToLive (void) const
| Gets the minimum time each particle will live for.
virtual Real | getMaxTimeToLive (void) const
| Gets the maximum time each particle will live for.
virtual void | setColour (const ColourValue &colour)
| Sets the initial colour of particles emitted.
virtual void | setColour (const ColourValue &colourStart, const ColourValue &colourEnd)
| Sets the range of colours for emitted particles.
virtual void | setColourRangeStart (const ColourValue &colour)
| Sets the minimum colour of particles to be emitted.
virtual void | setColourRangeEnd (const ColourValue &colour)
| Sets the maximum colour of particles to be emitted.
virtual const ColourValue & | getColour (void) const
| Gets the colour of particles to be emitted.
virtual const ColourValue & | getColourRangeStart (void) const
| Gets the minimum colour of particles to be emitted.
virtual const ColourValue & | getColourRangeEnd (void) const
| Gets the maximum colour of particles to be emitted.
virtual unsigned short | _getEmissionCount (Real timeElapsed)=0
| Gets the number of particles which this emitter would like to emit based on the time elapsed.
virtual void | _initParticle (Particle *pParticle)
| Initialises a particle based on the emitter's approach and parameters.
const String & | getType (void) const
| Returns the name of the type of emitter.
virtual void | setEnabled (bool enabled)
| Sets whether or not the emitter is enabled.
virtual bool | getEnabled (void) const
| Gets the flag indicating if this emitter is enabled or not.
virtual void | setStartTime (Real startTime)
| Sets the 'start time' of this emitter.
virtual Real | getStartTime (void) const
| Gets the start time of the emitter.
virtual void | setDuration (Real duration)
| Sets the duration of the emitter.
virtual Real | getDuration (void) const
| Gets the duration of the emitter from when it is created or re-enabled.
virtual void | setDuration (Real min, Real max)
| Sets the range of random duration for this emitter.
virtual void | setMinDuration (Real min)
| Sets the minimum duration of this emitter in seconds (see setDuration for more details).
virtual void | setMaxDuration (Real max)
| Sets the maximum duration of this emitter in seconds (see setDuration for more details).
virtual Real | getMinDuration (void) const
| Gets the minimum duration of this emitter in seconds (see setDuration for more details).
virtual Real | getMaxDuration (void) const
| Gets the maximum duration of this emitter in seconds (see setDuration for more details).
virtual void | setRepeatDelay (Real duration)
| Sets the time between repeats of the emitter.
virtual Real | getRepeatDelay (void) const
| Gets the duration of the emitter from when it is created or re-enabled.
virtual void | setRepeatDelay (Real min, Real max)
| Sets the range of random duration for this emitter.
virtual void | setMinRepeatDelay (Real min)
| Sets the minimum duration of this emitter in seconds (see setRepeatDelay for more details).
virtual void | setMaxRepeatDelay (Real max)
| Sets the maximum duration of this emitter in seconds (see setRepeatDelay for more details).
virtual Real | getMinRepeatDelay (void) const
| Gets the minimum duration of this emitter in seconds (see setRepeatDelay for more details).
virtual Real | getMaxRepeatDelay (void) const
| Gets the maximum duration of this emitter in seconds (see setRepeatDelay for more details).
const String & | getName (void) const
| Returns the name of the emitter.
virtual void | setName (const String &newName)
| Sets the name of the emitter.
const String & | getEmittedEmitter (void) const
| Returns the name of the emitter to be emitted.
virtual void | setEmittedEmitter (const String &emittedEmitter)
| Sets the name of the emitter to be emitted.
virtual bool | isEmitted (void) const
| Return ´true´ if the emitter is emitted by another emitter.
virtual void | setEmitted (bool emitted)
| Set the indication (true/false) to indicate that the emitter is emitted by another emitter.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
void | setDimensions (Real width, Real height)
| Sets the width and height for this particle.
bool | hasOwnDimensions (void) const
| Returns true if this particle deviates from the ParticleSystem's default dimensions (i.e.
Real | getOwnWidth (void) const
| Retrieves the particle's personal width, if hasOwnDimensions is true.
Real | getOwnHeight (void) const
| Retrieves the particle's personal width, if hasOwnDimensions is true.
void | setRotation (const Radian &rad)
| Sets the current rotation.
const Radian & | getRotation (void) const
void | _notifyOwner (ParticleSystem *owner)
| Internal method for notifying the particle of it's owner.
void | _notifyVisualData (ParticleVisualData *vis)
| Internal method for notifying the particle of it's optional visual data.
ParticleVisualData * | getVisualData (void) const
| Get the optional visual data associated with the class.
void | resetDimensions (void)
| Utility method to reset this particle.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
## Public Attributes
bool | mOwnDimensions
| Does this particle have it's own dimensions?
Real | mWidth
| Personal width if mOwnDimensions == true.
Real | mHeight
| Personal height if mOwnDimensions == true.
Radian | rotation
| Current rotation value.
Vector3 | position
| World position.
Vector3 | direction
| Direction (and speed).
ColourValue | colour
| Current colour.
Real | timeToLive
| Time to live, number of seconds left of particles natural life.
Real | totalTimeToLive
| Total Time to live, number of seconds of particles natural life.
Radian | rotationSpeed
| Speed of rotation in radians/sec.
ParticleType | particleType
| Determines the type of particle.
## Protected Member Functions
virtual void | genEmissionDirection (Vector3 &destVector)
| Internal utility method for generating particle exit direction.
virtual void | genEmissionVelocity (Vector3 &destVector)
| Internal utility method to apply velocity to a particle direction.
virtual Real | genEmissionTTL (void)
| Internal utility method for generating a time-to-live for a particle.
virtual void | genEmissionColour (ColourValue &destColour)
| Internal utility method for generating a colour for a particle.
virtual unsigned short | genConstantEmissionCount (Real timeElapsed)
| Internal utility method for generating an emission count based on a constant emission rate.
void | addBaseParameters (void)
| Internal method for setting up the basic parameter definitions for a subclass.
void | initDurationRepeat (void)
| Internal method for initialising the duration & repeat of an emitter.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.
## Protected Attributes
ParticleSystem * | mParent
| Parent particle system.
Vector3 | mPosition
| Position relative to the center of the ParticleSystem.
Real | mEmissionRate
| Rate in particles per second at which this emitter wishes to emit particles.
String | mType
| Name of the type of emitter, MUST be initialised by subclasses.
Vector3 | mDirection
| Base direction of the emitter, may not be used by some emitters.
Vector3 | mUp
Radian | mAngle
| Angle around direction which particles may be emitted, internally radians but angleunits for interface.
Real | mMinSpeed
| Min speed of particles.
Real | mMaxSpeed
| Max speed of particles.
Real | mMinTTL
| Initial time-to-live of particles (min).
Real | mMaxTTL
| Initial time-to-live of particles (max).
ColourValue | mColourRangeStart
| Initial colour of particles (range start).
ColourValue | mColourRangeEnd
| Initial colour of particles (range end).
bool | mEnabled
| Whether this emitter is currently enabled (defaults to true).
Real | mStartTime
| Start time (in seconds from start of first call to ParticleSystem to update).
Real | mDurationMin
| Minimum length of time emitter will run for (0 = forever).
Real | mDurationMax
| Maximum length of time the emitter will run for (0 = forever).
Real | mDurationRemain
| Current duration remainder.
Real | mRepeatDelayMin
| Time between each repeat.
Real | mRepeatDelayMax
Real | mRepeatDelayRemain
| Repeat delay left.
Real | mRemainder
String | mName
| The name of the emitter. The name is optional unless it is used as an emitter that is emitted itself.
String | mEmittedEmitter
| The name of the emitter to be emitted (optional).
bool | mEmitted
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).
ParticleSystem * | mParentSystem
| Parent ParticleSystem.
ParticleVisualData * | mVisual
| Additional visual data you might want to associate with the Particle.
## Static Protected Attributes
static EmitterCommands::CmdAngle | msAngleCmd
static EmitterCommands::CmdColour | msColourCmd
static EmitterCommands::CmdColourRangeStart | msColourRangeStartCmd
static EmitterCommands::CmdColourRangeEnd | msColourRangeEndCmd
static EmitterCommands::CmdDirection | msDirectionCmd
static EmitterCommands::CmdEmissionRate | msEmissionRateCmd
static EmitterCommands::CmdMaxTTL | msMaxTTLCmd
static EmitterCommands::CmdMaxVelocity | msMaxVelocityCmd
static EmitterCommands::CmdMinTTL | msMinTTLCmd
static EmitterCommands::CmdMinVelocity | msMinVelocityCmd
static EmitterCommands::CmdPosition | msPositionCmd
static EmitterCommands::CmdTTL | msTTLCmd
static EmitterCommands::CmdVelocity | msVelocityCmd
static EmitterCommands::CmdDuration | msDurationCmd
static EmitterCommands::CmdMinDuration | msMinDurationCmd
static EmitterCommands::CmdMaxDuration | msMaxDurationCmd
static EmitterCommands::CmdRepeatDelay | msRepeatDelayCmd
static EmitterCommands::CmdMinRepeatDelay | msMinRepeatDelayCmd
static EmitterCommands::CmdMaxRepeatDelay | msMaxRepeatDelayCmd
static EmitterCommands::CmdName | msNameCmd
static EmitterCommands::CmdEmittedEmitter | msEmittedEmitterCmd
static ParamDictionaryMap | msDictionary
| Dictionary of parameters.

## Detailed Description

Abstract class defining the interface to be implemented by particle emitters.

Remarks:
  Particle emitters are the sources of particles in a particle system. This class defines the ParticleEmitter interface, and provides a basic implementation for tasks which most emitters will do (these are of course overridable). Particle emitters can be grouped into types, e.g. 'point' emitters, 'box' emitters etc; each type will create particles with a different starting point, direction and velocity (although within the types you can configure the ranges of these parameters).

  Because there are so many types of emitters you could use, OGRE chooses not to dictate the available types. It comes with some in-built, but allows plugins or applications to extend the emitter types available. This is done by subclassing ParticleEmitter to have the appropriate emission behaviour you want, and also creating a subclass of ParticleEmitterFactory which is responsible for creating instances of your new emitter type. You register this factory with the ParticleSystemManager using addEmitterFactory, and from then on emitters of this type can be created either from code or through text particle scripts by naming the type.

  This same approach is used for ParticleAffectors (which modify existing particles per frame). This means that OGRE is particularly flexible when it comes to creating particle system effects, with literally infinite combinations of emitter and affector types, and paramters within those types.

Definition at line 66 of file OgreParticleEmitter.h.

## Member Enumeration Documentation

enum Ogre::Particle::ParticleType`[inherited]`

Type of particle.

Enumerator:

  Visual |
  Emitter |

Definition at line 64 of file OgreParticle.h.

## Constructor & Destructor Documentation

Ogre::ParticleEmitter::ParticleEmitter | ( | ParticleSystem * | psys | ) |

virtual Ogre::ParticleEmitter::~ParticleEmitter | ( |  | ) | `[virtual]`

Virtual destructor essential.

## Member Function Documentation

virtual void Ogre::ParticleEmitter::genEmissionDirection | ( | Vector3 & | destVector | ) | `[protected, virtual]`

Internal utility method for generating particle exit direction.

Parameters:

  | destVector | Reference to vector to complete with new direction (normalised)

virtual void Ogre::ParticleEmitter::genEmissionVelocity | ( | Vector3 & | destVector | ) | `[protected, virtual]`

Internal utility method to apply velocity to a particle direction.

Parameters:

  | destVector | The vector to scale by a randomly generated scale between min and max speed. Assumed normalised already, and likely already oriented in the right direction.

virtual Real Ogre::ParticleEmitter::genEmissionTTL | ( | void |  | ) | `[protected, virtual]`

Internal utility method for generating a time-to-live for a particle.

virtual void Ogre::ParticleEmitter::genEmissionColour | ( | ColourValue & | destColour | ) | `[protected, virtual]`

Internal utility method for generating a colour for a particle.

virtual unsigned short Ogre::ParticleEmitter::genConstantEmissionCount | ( | Real | timeElapsed | ) | `[protected, virtual]`

Internal utility method for generating an emission count based on a constant emission rate.

void Ogre::ParticleEmitter::addBaseParameters | ( | void |  | ) | `[protected]`

Internal method for setting up the basic parameter definitions for a subclass.

Remarks:
  Because StringInterface holds a dictionary of parameters per class, subclasses need to call this to ask the base class to add it's parameters to their dictionary as well. Can't do this in the constructor because that runs in a non-virtual context.

  The subclass must have called it's own createParamDictionary before calling this method.

void Ogre::ParticleEmitter::initDurationRepeat | ( | void |  | ) | `[protected]`

Internal method for initialising the duration & repeat of an emitter.

virtual void Ogre::ParticleEmitter::setPosition | ( | const Vector3 & | pos | ) | `[virtual]`

Sets the position of this emitter relative to the particle system center.

virtual const Vector3& Ogre::ParticleEmitter::getPosition | ( | void |  | ) | const`[virtual]`

Returns the position of this emitter relative to the center of the particle system.

virtual void Ogre::ParticleEmitter::setDirection | ( | const Vector3 & | direction | ) | `[virtual]`

Sets the direction of the emitter.

Remarks:
  Most emitters will have a base direction in which they emit particles (those which emit in all directions will ignore this parameter). They may not emit exactly along this vector for every particle, many will introduce a random scatter around this vector using the angle property.

Parameters:

  | direction | The base direction for particles emitted.

virtual const Vector3& Ogre::ParticleEmitter::getDirection | ( | void |  | ) | const`[virtual]`

Returns the base direction of the emitter.

virtual void Ogre::ParticleEmitter::setAngle | ( | const Radian & | angle | ) | `[virtual]`

Sets the maximum angle away from the emitter direction which particle will be emitted.

Remarks:
  Whilst the direction property defines the general direction of emission for particles, this property defines how far the emission angle can deviate away from this base direction. This allows you to create a scatter effect - if set to 0, all particles will be emitted exactly along the emitters direction vector, whereas if you set it to 180 degrees or more, particles will be emitted in a sphere, i.e. in all directions.

Parameters:

  | degrees | Maximum angle which initial particle direction can deviate from the emitter base direction vector.

virtual const Radian& Ogre::ParticleEmitter::getAngle | ( | void |  | ) | const`[virtual]`

Returns the maximum angle which the initial particle direction can deviate from the emitters base direction.

virtual void Ogre::ParticleEmitter::setParticleVelocity | ( | Real | speed | ) | `[virtual]`

Sets the initial velocity of particles emitted.

Remarks:
  This method sets a constant speed for emitted particles. See the alternate version of this method which takes 2 parameters if you want a variable speed.

Parameters:

  | speed | The initial speed in world units per second which every particle emitted starts with.

virtual void Ogre::ParticleEmitter::setParticleVelocity | ( | Real | min,
|  | Real | max |
| ) |  |  | `[virtual]`

Sets the initial velocity range of particles emitted.

Remarks:
  This method sets the range of starting speeds for emitted particles. See the alternate version of this method which takes 1 parameter if you want a constant speed. This emitter will randomly choose a speed between the minimum and maximum for each particle.

Parameters:

  | max | The maximum speed in world units per second for the initial particle speed on emission.
  | min | The minimum speed in world units per second for the initial particle speed on emission.

virtual void Ogre::ParticleEmitter::setMinParticleVelocity | ( | Real | min | ) | `[virtual]`

Returns the minimum particle velocity.

virtual void Ogre::ParticleEmitter::setMaxParticleVelocity | ( | Real | max | ) | `[virtual]`

Returns the maximum particle velocity.

virtual Real Ogre::ParticleEmitter::getParticleVelocity | ( | void |  | ) | const`[virtual]`

Returns the initial velocity of particles emitted.

virtual Real Ogre::ParticleEmitter::getMinParticleVelocity | ( | void |  | ) | const`[virtual]`

Returns the minimum particle velocity.

virtual Real Ogre::ParticleEmitter::getMaxParticleVelocity | ( | void |  | ) | const`[virtual]`

Returns the maximum particle velocity.

virtual void Ogre::ParticleEmitter::setEmissionRate | ( | Real | particlesPerSecond | ) | `[virtual]`

Sets the emission rate for this emitter.

Remarks:
  This method tells the emitter how many particles per second should be emitted. The emitter subclass does not have to emit these in a continuous burst - this is a relative parameter and the emitter may choose to emit all of the second's worth of particles every half-second for example. This is controlled by the emitter's getEmissionCount method.

  Also, if the ParticleSystem's particle quota is exceeded, not all the particles requested may be actually emitted.

Parameters:

  | particlesPerSecond | The number of particles to be emitted every second.

virtual Real Ogre::ParticleEmitter::getEmissionRate | ( | void |  | ) | const`[virtual]`

Returns the emission rate set for this emitter.

virtual void Ogre::ParticleEmitter::setTimeToLive | ( | Real | ttl | ) | `[virtual]`

Sets the lifetime of all particles emitted.

Remarks:
  The emitter initialises particles with a time-to-live (TTL), the number of seconds a particle will exist before being destroyed. This method sets a constant TTL for all particles emitted. Note that affectors are able to modify the TTL of particles later.

  Also see the alternate version of this method which takes a min and max TTL in order to have the TTL vary per particle.

Parameters:

  | ttl | The number of seconds each particle will live for.

virtual void Ogre::ParticleEmitter::setTimeToLive | ( | Real | minTtl,
|  | Real | maxTtl |
| ) |  |  | `[virtual]`

Sets the range of lifetime for particles emitted.

Remarks:
  The emitter initialises particles with a time-to-live (TTL), the number of seconds a particle will exist before being destroyed. This method sets a range for the TTL for all particles emitted; the ttl may be randomised between these 2 extremes or will vary some other way depending on the emitter. Note that affectors are able to modify the TTL of particles later.

  Also see the alternate version of this method which takes a single TTL in order to set a constant TTL for all particles.

Parameters:

  | minTtl | The minimum number of seconds each particle will live for.
  | maxTtl | The maximum number of seconds each particle will live for.

virtual void Ogre::ParticleEmitter::setMinTimeToLive | ( | Real | min | ) | `[virtual]`

Sets the minimum time each particle will live for.

virtual void Ogre::ParticleEmitter::setMaxTimeToLive | ( | Real | max | ) | `[virtual]`

Sets the maximum time each particle will live for.

virtual Real Ogre::ParticleEmitter::getTimeToLive | ( | void |  | ) | const`[virtual]`

Gets the time each particle will live for.

virtual Real Ogre::ParticleEmitter::getMinTimeToLive | ( | void |  | ) | const`[virtual]`

Gets the minimum time each particle will live for.

virtual Real Ogre::ParticleEmitter::getMaxTimeToLive | ( | void |  | ) | const`[virtual]`

Gets the maximum time each particle will live for.

virtual void Ogre::ParticleEmitter::setColour | ( | const ColourValue & | colour | ) | `[virtual]`

Sets the initial colour of particles emitted.

Remarks:
  Particles have an initial colour on emission which the emitter sets. This method sets this colour. See the alternate version of this method which takes 2 colours in order to establish a range of colours to be assigned to particles.

Parameters:

  | colour | The colour which all particles will be given on emission.

virtual void Ogre::ParticleEmitter::setColour | ( | const ColourValue & | colourStart,
|  | const ColourValue & | colourEnd |
| ) |  |  | `[virtual]`

Sets the range of colours for emitted particles.

Remarks:
  Particles have an initial colour on emission which the emitter sets. This method sets the range of this colour. See the alternate version of this method which takes a single colour in order to set a constant colour for all particles. Emitters may choose to randomly assign a colour in this range, or may use some other method to vary the colour.

Parameters:

  | colourStart | The start of the colour range
  | colourEnd | The end of the colour range

virtual void Ogre::ParticleEmitter::setColourRangeStart | ( | const ColourValue & | colour | ) | `[virtual]`

Sets the minimum colour of particles to be emitted.

virtual void Ogre::ParticleEmitter::setColourRangeEnd | ( | const ColourValue & | colour | ) | `[virtual]`

Sets the maximum colour of particles to be emitted.

virtual const ColourValue& Ogre::ParticleEmitter::getColour | ( | void |  | ) | const`[virtual]`

Gets the colour of particles to be emitted.

virtual const ColourValue& Ogre::ParticleEmitter::getColourRangeStart | ( | void |  | ) | const`[virtual]`

Gets the minimum colour of particles to be emitted.

virtual const ColourValue& Ogre::ParticleEmitter::getColourRangeEnd | ( | void |  | ) | const`[virtual]`

Gets the maximum colour of particles to be emitted.

virtual unsigned short Ogre::ParticleEmitter::_getEmissionCount | ( | Real | timeElapsed | ) | `[pure virtual]`

Gets the number of particles which this emitter would like to emit based on the time elapsed.

Remarks:
  For efficiency the emitter does not actually create new Particle instances (these are reused by the ParticleSystem as existing particles 'die'). The implementation for this method must return the number of particles the emitter would like to emit given the number of seconds which have elapsed (passed in as a parameter).

  Based on the return value from this method, the ParticleSystem class will call _initParticle once for each particle it chooses to allow to be emitted by this emitter. The emitter should not track these _initParticle calls, it should assume all emissions requested were made (even if they could not be because of particle quotas).

virtual void Ogre::ParticleEmitter::_initParticle | ( | Particle * | pParticle | ) | `[virtual]`

Initialises a particle based on the emitter's approach and parameters.

Remarks:
  See the _getEmissionCount method for details of why there is a separation between 'requested' emissions and actual initialised particles.

Parameters:

  | pParticle | Pointer to a particle which must be initialised based on how this emitter starts particles. This is passed as a pointer rather than being created by the emitter so the ParticleSystem can reuse Particle instances, and can also set defaults itself.

Definition at line 371 of file OgreParticleEmitter.h.

References Ogre::Particle::resetDimensions().

const String& Ogre::ParticleEmitter::getType | ( | void |  | ) | const

Returns the name of the type of emitter.

Remarks:
  This property is useful for determining the type of emitter procedurally so another can be created.

Definition at line 382 of file OgreParticleEmitter.h.

virtual void Ogre::ParticleEmitter::setEnabled | ( | bool | enabled | ) | `[virtual]`

Sets whether or not the emitter is enabled.

Remarks:
  You can turn an emitter off completely by setting this parameter to false.

virtual bool Ogre::ParticleEmitter::getEnabled | ( | void |  | ) | const`[virtual]`

Gets the flag indicating if this emitter is enabled or not.

virtual void Ogre::ParticleEmitter::setStartTime | ( | Real | startTime | ) | `[virtual]`

Sets the 'start time' of this emitter.

Remarks:
  By default an emitter starts straight away as soon as a ParticleSystem is first created, or also just after it is re-enabled. This parameter allows you to set a time delay so that the emitter does not 'kick in' until later.

Parameters:

  | startTime | The time in seconds from the creation or enabling of the emitter.

virtual Real Ogre::ParticleEmitter::getStartTime | ( | void |  | ) | const`[virtual]`

Gets the start time of the emitter.

virtual void Ogre::ParticleEmitter::setDuration | ( | Real | duration | ) | `[virtual]`

Sets the duration of the emitter.

Remarks:
  By default emitters run indefinitely (unless you manually disable them). By setting this parameter, you can make an emitter turn off on it's own after a set number of seconds. It will then remain disabled until either setEnabled(true) is called, or if the 'repeatAfter' parameter has been set it will also repeat after a number of seconds.

  Also see the alternative version of this method which allows you to set a min and max duration for a random variable duration.

Parameters:

  | duration | The duration in seconds.

virtual Real Ogre::ParticleEmitter::getDuration | ( | void |  | ) | const`[virtual]`

Gets the duration of the emitter from when it is created or re-enabled.

virtual void Ogre::ParticleEmitter::setDuration | ( | Real | min,
|  | Real | max |
| ) |  |  | `[virtual]`

Sets the range of random duration for this emitter.

Remarks:
  By default emitters run indefinitely (unless you manually disable them). By setting this parameter, you can make an emitter turn off on it's own after a random number of seconds. It will then remain disabled until either setEnabled(true) is called, or if the 'repeatAfter' parameter has been set it will also repeat after a number of seconds.

  Also see the alternative version of this method which allows you to set a constant duration.

Parameters:

  | min | The minimum duration in seconds.
  | max | The minimum duration in seconds.

virtual void Ogre::ParticleEmitter::setMinDuration | ( | Real | min | ) | `[virtual]`

Sets the minimum duration of this emitter in seconds (see setDuration for more details).

virtual void Ogre::ParticleEmitter::setMaxDuration | ( | Real | max | ) | `[virtual]`

Sets the maximum duration of this emitter in seconds (see setDuration for more details).

virtual Real Ogre::ParticleEmitter::getMinDuration | ( | void |  | ) | const`[virtual]`

Gets the minimum duration of this emitter in seconds (see setDuration for more details).

virtual Real Ogre::ParticleEmitter::getMaxDuration | ( | void |  | ) | const`[virtual]`

Gets the maximum duration of this emitter in seconds (see setDuration for more details).

virtual void Ogre::ParticleEmitter::setRepeatDelay | ( | Real | duration | ) | `[virtual]`

Sets the time between repeats of the emitter.

Remarks:
  By default emitters run indefinitely (unless you manually disable them). However, if you manually disable the emitter (by calling setEnabled(false), or it's duration runs out, it will cease to emit

  Also see the alternative version of this method which allows you to set a min and max duration for a random variable duration.

Parameters:

  | duration | The duration in seconds.

virtual Real Ogre::ParticleEmitter::getRepeatDelay | ( | void |  | ) | const`[virtual]`

Gets the duration of the emitter from when it is created or re-enabled.

virtual void Ogre::ParticleEmitter::setRepeatDelay | ( | Real | min,
|  | Real | max |
| ) |  |  | `[virtual]`

Sets the range of random duration for this emitter.

Remarks:
  By default emitters run indefinitely (unless you manually disable them). By setting this parameter, you can make an emitter turn off on it's own after a random number of seconds. It will then remain disabled until either setEnabled(true) is called, or if the 'repeatAfter' parameter has been set it will also repeat after a number of seconds.

  Also see the alternative version of this method which allows you to set a constant duration.

Parameters:

  | min | The minimum duration in seconds.
  | max | The minimum duration in seconds.

virtual void Ogre::ParticleEmitter::setMinRepeatDelay | ( | Real | min | ) | `[virtual]`

Sets the minimum duration of this emitter in seconds (see setRepeatDelay for more details).

virtual void Ogre::ParticleEmitter::setMaxRepeatDelay | ( | Real | max | ) | `[virtual]`

Sets the maximum duration of this emitter in seconds (see setRepeatDelay for more details).

virtual Real Ogre::ParticleEmitter::getMinRepeatDelay | ( | void |  | ) | const`[virtual]`

Gets the minimum duration of this emitter in seconds (see setRepeatDelay for more details).

virtual Real Ogre::ParticleEmitter::getMaxRepeatDelay | ( | void |  | ) | const`[virtual]`

Gets the maximum duration of this emitter in seconds (see setRepeatDelay for more details).

const String& Ogre::ParticleEmitter::getName | ( | void |  | ) | const

Returns the name of the emitter.

virtual void Ogre::ParticleEmitter::setName | ( | const String & | newName | ) | `[virtual]`

Sets the name of the emitter.

const String& Ogre::ParticleEmitter::getEmittedEmitter | ( | void |  | ) | const

Returns the name of the emitter to be emitted.

virtual void Ogre::ParticleEmitter::setEmittedEmitter | ( | const String & | emittedEmitter | ) | `[virtual]`

Sets the name of the emitter to be emitted.

virtual bool Ogre::ParticleEmitter::isEmitted | ( | void |  | ) | const`[virtual]`

Return ´true´ if the emitter is emitted by another emitter.

virtual void Ogre::ParticleEmitter::setEmitted | ( | bool | emitted | ) | `[virtual]`

Set the indication (true/false) to indicate that the emitter is emitted by another emitter.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 176 of file OgreStringInterface.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 200 of file OgreStringInterface.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

Definition at line 213 of file OgreStringInterface.h.

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value |
| ) |  |  | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 269 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 300 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and Ogre::StringInterface::setParameter().

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

void Ogre::Particle::setDimensions | ( | Real | width,
|  | Real | height |
| ) |  |  | `[inherited]`

Sets the width and height for this particle.

Remarks:
  Note that it is most efficient for every particle in a ParticleSystem to have the same dimensions. If you choose to alter the dimensions of an individual particle the set will be less efficient. Do not call this method unless you really need to have different particle dimensions within the same set. Otherwise just call the ParticleSystem::setDefaultDimensions method instead.

bool Ogre::Particle::hasOwnDimensions | ( | void |  | ) | const`[inherited]`

Returns true if this particle deviates from the ParticleSystem's default dimensions (i.e.

if the particle::setDimensions method has been called for this instance).

See also:
  particle::setDimensions

Definition at line 117 of file OgreParticle.h.

Real Ogre::Particle::getOwnWidth | ( | void |  | ) | const`[inherited]`

Retrieves the particle's personal width, if hasOwnDimensions is true.

Definition at line 120 of file OgreParticle.h.

Real Ogre::Particle::getOwnHeight | ( | void |  | ) | const`[inherited]`

Retrieves the particle's personal width, if hasOwnDimensions is true.

Definition at line 123 of file OgreParticle.h.

void Ogre::Particle::setRotation | ( | const Radian & | rad | ) | `[inherited]`

Sets the current rotation.

const Radian& Ogre::Particle::getRotation | ( | void |  | ) | const`[inherited]`

Definition at line 128 of file OgreParticle.h.

void Ogre::Particle::_notifyOwner | ( | ParticleSystem * | owner | ) | `[inherited]`

Internal method for notifying the particle of it's owner.

void Ogre::Particle::_notifyVisualData | ( | ParticleVisualData * | vis | ) | `[inherited]`

Internal method for notifying the particle of it's optional visual data.

Definition at line 136 of file OgreParticle.h.

ParticleVisualData* Ogre::Particle::getVisualData | ( | void |  | ) | const`[inherited]`

Get the optional visual data associated with the class.

Definition at line 139 of file OgreParticle.h.

void Ogre::Particle::resetDimensions | ( | void |  | ) | `[inherited]`

Utility method to reset this particle.

Referenced by _initParticle().

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

EmitterCommands::CmdAngle Ogre::ParticleEmitter::msAngleCmd`[static, protected]`

Definition at line 71 of file OgreParticleEmitter.h.

EmitterCommands::CmdColour Ogre::ParticleEmitter::msColourCmd`[static, protected]`

Definition at line 72 of file OgreParticleEmitter.h.

EmitterCommands::CmdColourRangeStart Ogre::ParticleEmitter::msColourRangeStartCmd`[static, protected]`

Definition at line 73 of file OgreParticleEmitter.h.

EmitterCommands::CmdColourRangeEnd Ogre::ParticleEmitter::msColourRangeEndCmd`[static, protected]`

Definition at line 74 of file OgreParticleEmitter.h.

EmitterCommands::CmdDirection Ogre::ParticleEmitter::msDirectionCmd`[static, protected]`

Definition at line 75 of file OgreParticleEmitter.h.

EmitterCommands::CmdEmissionRate Ogre::ParticleEmitter::msEmissionRateCmd`[static, protected]`

Definition at line 76 of file OgreParticleEmitter.h.

EmitterCommands::CmdMaxTTL Ogre::ParticleEmitter::msMaxTTLCmd`[static, protected]`

Definition at line 77 of file OgreParticleEmitter.h.

EmitterCommands::CmdMaxVelocity Ogre::ParticleEmitter::msMaxVelocityCmd`[static, protected]`

Definition at line 78 of file OgreParticleEmitter.h.

EmitterCommands::CmdMinTTL Ogre::ParticleEmitter::msMinTTLCmd`[static, protected]`

Definition at line 79 of file OgreParticleEmitter.h.

EmitterCommands::CmdMinVelocity Ogre::ParticleEmitter::msMinVelocityCmd`[static, protected]`

Definition at line 80 of file OgreParticleEmitter.h.

EmitterCommands::CmdPosition Ogre::ParticleEmitter::msPositionCmd`[static, protected]`

Definition at line 81 of file OgreParticleEmitter.h.

EmitterCommands::CmdTTL Ogre::ParticleEmitter::msTTLCmd`[static, protected]`

Definition at line 82 of file OgreParticleEmitter.h.

EmitterCommands::CmdVelocity Ogre::ParticleEmitter::msVelocityCmd`[static, protected]`

Definition at line 83 of file OgreParticleEmitter.h.

EmitterCommands::CmdDuration Ogre::ParticleEmitter::msDurationCmd`[static, protected]`

Definition at line 84 of file OgreParticleEmitter.h.

EmitterCommands::CmdMinDuration Ogre::ParticleEmitter::msMinDurationCmd`[static, protected]`

Definition at line 85 of file OgreParticleEmitter.h.

EmitterCommands::CmdMaxDuration Ogre::ParticleEmitter::msMaxDurationCmd`[static, protected]`

Definition at line 86 of file OgreParticleEmitter.h.

EmitterCommands::CmdRepeatDelay Ogre::ParticleEmitter::msRepeatDelayCmd`[static, protected]`

Definition at line 87 of file OgreParticleEmitter.h.

EmitterCommands::CmdMinRepeatDelay Ogre::ParticleEmitter::msMinRepeatDelayCmd`[static, protected]`

Definition at line 88 of file OgreParticleEmitter.h.

EmitterCommands::CmdMaxRepeatDelay Ogre::ParticleEmitter::msMaxRepeatDelayCmd`[static, protected]`

Definition at line 89 of file OgreParticleEmitter.h.

EmitterCommands::CmdName Ogre::ParticleEmitter::msNameCmd`[static, protected]`

Definition at line 90 of file OgreParticleEmitter.h.

EmitterCommands::CmdEmittedEmitter Ogre::ParticleEmitter::msEmittedEmitterCmd`[static, protected]`

Definition at line 91 of file OgreParticleEmitter.h.

ParticleSystem* Ogre::ParticleEmitter::mParent`[protected]`

Parent particle system.

Definition at line 95 of file OgreParticleEmitter.h.

Vector3 Ogre::ParticleEmitter::mPosition`[protected]`

Position relative to the center of the ParticleSystem.

Definition at line 97 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mEmissionRate`[protected]`

Rate in particles per second at which this emitter wishes to emit particles.

Definition at line 99 of file OgreParticleEmitter.h.

String Ogre::ParticleEmitter::mType`[protected]`

Name of the type of emitter, MUST be initialised by subclasses.

Definition at line 101 of file OgreParticleEmitter.h.

Vector3 Ogre::ParticleEmitter::mDirection`[protected]`

Base direction of the emitter, may not be used by some emitters.

Definition at line 103 of file OgreParticleEmitter.h.

Vector3 Ogre::ParticleEmitter::mUp`[protected]`

Definition at line 105 of file OgreParticleEmitter.h.

Radian Ogre::ParticleEmitter::mAngle`[protected]`

Angle around direction which particles may be emitted, internally radians but angleunits for interface.

Definition at line 107 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mMinSpeed`[protected]`

Min speed of particles.

Definition at line 109 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mMaxSpeed`[protected]`

Max speed of particles.

Definition at line 111 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mMinTTL`[protected]`

Initial time-to-live of particles (min).

Definition at line 113 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mMaxTTL`[protected]`

Initial time-to-live of particles (max).

Definition at line 115 of file OgreParticleEmitter.h.

ColourValue Ogre::ParticleEmitter::mColourRangeStart`[protected]`

Initial colour of particles (range start).

Definition at line 117 of file OgreParticleEmitter.h.

ColourValue Ogre::ParticleEmitter::mColourRangeEnd`[protected]`

Initial colour of particles (range end).

Definition at line 119 of file OgreParticleEmitter.h.

bool Ogre::ParticleEmitter::mEnabled`[protected]`

Whether this emitter is currently enabled (defaults to true).

Definition at line 122 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mStartTime`[protected]`

Start time (in seconds from start of first call to ParticleSystem to update).

Definition at line 125 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mDurationMin`[protected]`

Minimum length of time emitter will run for (0 = forever).

Definition at line 127 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mDurationMax`[protected]`

Maximum length of time the emitter will run for (0 = forever).

Definition at line 129 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mDurationRemain`[protected]`

Current duration remainder.

Definition at line 131 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mRepeatDelayMin`[protected]`

Time between each repeat.

Definition at line 134 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mRepeatDelayMax`[protected]`

Definition at line 135 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mRepeatDelayRemain`[protected]`

Repeat delay left.

Definition at line 137 of file OgreParticleEmitter.h.

Real Ogre::ParticleEmitter::mRemainder`[protected]`

Definition at line 140 of file OgreParticleEmitter.h.

String Ogre::ParticleEmitter::mName`[protected]`

The name of the emitter. The name is optional unless it is used as an emitter that is emitted itself.

Definition at line 143 of file OgreParticleEmitter.h.

String Ogre::ParticleEmitter::mEmittedEmitter`[protected]`

The name of the emitter to be emitted (optional).

Definition at line 146 of file OgreParticleEmitter.h.

bool Ogre::ParticleEmitter::mEmitted`[protected]`

Definition at line 150 of file OgreParticleEmitter.h.

ParamDictionaryMap Ogre::StringInterface::msDictionary`[static, protected, inherited]`

Dictionary of parameters.

Definition at line 161 of file OgreStringInterface.h.

String Ogre::StringInterface::mParamDictName`[protected, inherited]`

Class name for this instance to be used as a lookup (must be initialised by subclasses).

Definition at line 164 of file OgreStringInterface.h.

ParticleSystem* Ogre::Particle::mParentSystem`[protected, inherited]`

Parent ParticleSystem.

Definition at line 59 of file OgreParticle.h.

ParticleVisualData* Ogre::Particle::mVisual`[protected, inherited]`

Additional visual data you might want to associate with the Particle.

Definition at line 61 of file OgreParticle.h.

bool Ogre::Particle::mOwnDimensions`[inherited]`

Does this particle have it's own dimensions?

Definition at line 71 of file OgreParticle.h.

Real Ogre::Particle::mWidth`[inherited]`

Personal width if mOwnDimensions == true.

Definition at line 73 of file OgreParticle.h.

Real Ogre::Particle::mHeight`[inherited]`

Personal height if mOwnDimensions == true.

Definition at line 75 of file OgreParticle.h.

Radian Ogre::Particle::rotation`[inherited]`

Current rotation value.

Definition at line 77 of file OgreParticle.h.

Vector3 Ogre::Particle::position`[inherited]`

World position.

Definition at line 81 of file OgreParticle.h.

Vector3 Ogre::Particle::direction`[inherited]`

Direction (and speed).

Definition at line 83 of file OgreParticle.h.

ColourValue Ogre::Particle::colour`[inherited]`

Current colour.

Definition at line 85 of file OgreParticle.h.

Real Ogre::Particle::timeToLive`[inherited]`

Time to live, number of seconds left of particles natural life.

Definition at line 87 of file OgreParticle.h.

Real Ogre::Particle::totalTimeToLive`[inherited]`

Total Time to live, number of seconds of particles natural life.

Definition at line 89 of file OgreParticle.h.

Radian Ogre::Particle::rotationSpeed`[inherited]`

Speed of rotation in radians/sec.

Definition at line 91 of file OgreParticle.h.

ParticleType Ogre::Particle::particleType`[inherited]`

Determines the type of particle.

Definition at line 93 of file OgreParticle.h.

The documentation for this class was generated from the following file:

- OgreParticleEmitter.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:34:41 2009